---------------------------------------------------------------
--
--                    Top Graph'X
--
-- For any information call J.C. Mahieux :
-- Tel : (33) 1 69 26 97 88
-- Fax : (33) 1 69 26 97 89
--
-- Top Graph'X - 10 Allee de la Mare Jacob
--               91290 La Norville- FRANCE
--
---------------------------------------------------------------
--
------------------ Distribution and Copyright -----------------
--
-- This Ada language binding to the PEX extension to the X Window System
-- inherits the Sun Microsystem copyright. The following copyright must
-- be included in all software utilising this binding.
--
-- Copyright 1992 J.C. Mahieux and B. Maudry
-- Copyright 1989, 1990, 1991 by Sun Microsystems, Inc. and the X Consortium.
--
--   
--   Package : Pex_Events
--    
--   Version : 5.1
--    
--   Subject : PEX Extension Events functions
--
--         Print_Pex_Error
--         To_Pex_Error
--         To_Pex_Event
--
with X_Types ;
with Pex_Types ;
with Text_Io ;

package Pex_Events is
    use Pex_Types ;
    
    --=============================================================== =======
    --  <Subprogram Name>
    --
    --  Print_Pex_Error
    --
    --  <Description>
    --
    --  This procedure displays in text form the contents of a Pex error event
    --
    --  <Parameters>
    --
    --  File     : indicates where to print.
    --  An_Error : the PEX error event to dump
    --
    --  <Called By>
    --
    --  External.
    --
    --=============================================================== =======

    procedure Print_Pex_Error ( File     : in Text_Io.File_Type;
                                An_Error : in X_Types.Event ) ;
    
    procedure Print_Pex_Error ( File     : in Text_Io.File_Type;
                                An_Error : in Pex_Error_Record ) ;
    
    
    --=============================================================== =======
    --  <Subprogram Name>
    --
    --  To_Pex_Error
    --
    --  <Description>
    --
    --  This function translates the contents of a Pex error event into
    --  a Pex error record.
    --
    --  <Parameters>
    --
    --  An_Error : the PEX error event to translate.
    --
    --  <Called By>
    --
    --  External.
    --
    --=============================================================== =======

    function To_Pex_Error  ( An_Error : in X_Types.Event )
        return Pex_Error_Record ;
    
    --=============================================================== =======
    --  <Subprogram Name>
    --
    --  To_Pex_Event
    --
    --  <Description>
    --
    --  This function translates the contents of an event into
    --  a Pex event record.
    --
    --  <Parameters>
    --
    --  An_Event : the event to translate.
    --
    --  <Called By>
    --
    --  External.
    --
    --=============================================================== =======

    function To_Pex_Event  ( An_Event : in X_Types.Event )
        return Pex_Event ;
    
end Pex_Events ;

