---------------------------------------------------------------
--
--                    Top Graph'X
--
-- For any information call J.C. Mahieux :
-- Tel : (33) 1 69 26 97 88
-- Fax : (33) 1 69 26 97 89
--
-- Top Graph'X - 10 Allee de la Mare Jacob
--               91290 La Norville- FRANCE
--
---------------------------------------------------------------
--
------------------ Distribution and Copyright -----------------
-- Derivation   : MIT X Window System, V11.R4
--
-- This Ada language binding to the X Window System inherits
-- the MIT copyright. The following copyright must be included
-- in all software utilising this binding.
--
-- Copyright 1990, 1991 J.C. Mahieux and B. Maudry
-- Copyright 1985, 1986, 1987 by the Massachusetts Institute of Technology
-- Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,


package X_Key_Symbols is
    type Symbol is ( No_Symbol,
                     Key_Space,
                     Key_Exclam,
                     Key_Quoted_Bl,
                     Key_Number_Sign,
                     Key_Dollar,
                     Key_Percent,
                     Key_Ampersand,
                     Key_Apostrophe,
                     Key_Paren_Left,
                     Key_Paren_Right,
                     Key_Asterisk,
                     Key_Plus,
                     Key_Comma,
                     Key_Minus,
                     Key_Period,
                     Key_Slash,
                     Key_0,
                     Key_1,
                     Key_2,
                     Key_3,
                     Key_4,
                     Key_5,
                     Key_6,
                     Key_7,
                     Key_8,
                     Key_9,
                     Key_Colon,
                     Key_Semi_Colon,
                     Key_Less,
                     Key_Equal,
                     Key_Greater,
                     Key_Question,
                     Key_At,
                     Key_A,
                     Key_B,
                     Key_C,
                     Key_D,
                     Key_E,
                     Key_F,
                     Key_G,
                     Key_H,
                     Key_I,
                     Key_J,
                     Key_K,
                     Key_L,
                     Key_M,
                     Key_N,
                     Key_O,
                     Key_P,
                     Key_Q,
                     Key_R,
                     Key_S,
                     Key_T,
                     Key_U,
                     Key_V,
                     Key_W,
                     Key_X,
                     Key_Y,
                     Key_Z,
                     Key_Bracket_Left,
                     Key_Back_Slash,
                     Key_Bracket_Right,
                     Key_Ascii_Circum,
                     Key_Underscore,
                     Key_Grave,
                     Key_Lc_A,
                     Key_Lc_B,
                     Key_Lc_C,
                     Key_Lc_D,
                     Key_Lc_E,
                     Key_Lc_F,
                     Key_Lc_G,
                     Key_Lc_H,
                     Key_Lc_I,
                     Key_Lc_J,
                     Key_Lc_K,
                     Key_Lc_L,
                     Key_Lc_M,
                     Key_Lc_N,
                     Key_Lc_O,
                     Key_Lc_P,
                     Key_Lc_Q,
                     Key_Lc_R,
                     Key_Lc_S,
                     Key_Lc_T,
                     Key_Lc_U,
                     Key_Lc_V,
                     Key_Lc_W,
                     Key_Lc_X,
                     Key_Lc_Y,
                     Key_Lc_Z,
                     Key_Brace_Left,
                     Key_Bar,
                     Key_Brace_Right,
                     Key_Ascii_Tilde,
                     Key_No_Break_Space,
                     Key_Exclam_Down,
                     Key_Cent,
                     Key_Sterling,
                     Key_Currency,
                     Key_Yen,
                     Key_Broken_Bar,
                     Key_Section,
                     Key_Diaeresis,
                     Key_Copyright,
                     Key_Ord_Feminine,
                     Key_Guillemot_Left,    -- left angle quotation mark
                     Key_Notsign,
                     Key_Hyphen,
                     Key_Registered,
                     Key_Macron,
                     Key_Degree,
                     Key_Plus_Minus,
                     Key_Two_Superior,
                     Key_Three_Superior,
                     Key_Acute,
                     Key_Mu,
                     Key_Paragraph,
                     Key_Period_Centered,
                     Key_Cedilla,
                     Key_One_Superior,
                     Key_Masculine,
                     Key_Guillemot_Right,    -- right angle quotation mark
                     Key_One_Quarter,
                     Key_One_Half,
                     Key_Three_Quarters,
                     Key_Question_Down,
                     Key_A_Grave,
                     Key_A_Acute,
                     Key_A_Circumflex,
                     Key_A_Tilde,
                     Key_A_Diaeresis,
                     Key_A_Ring,
                     Key_Ae,
                     Key_C_Cedilla,
                     Key_E_Grave,
                     Key_E_Acute,
                     Key_E_Circumflex,
                     Key_E_Diaeresis,
                     Key_I_Grave,
                     Key_I_Acute,
                     Key_I_Circumflex,
                     Key_I_Diaeresis,
                     Key_Eth,
                     Key_N_Tilde,
                     Key_O_Grave,
                     Key_O_Acute,
                     Key_O_Circumflex,
                     Key_O_Tilde,
                     Key_O_Diaeresis,
                     Key_Multiply,
                     Key_O_Oblique,
                     Key_U_Grave,
                     Key_U_Acute,
                     Key_U_Circumflex,
                     Key_U_Diaeresis,
                     Key_Y_Acute,
                     Key_Thorn,
                     Key_Lc_S_Sharp,
                     Key_Lc_A_Grave,
                     Key_Lc_A_Acute,
                     Key_Lc_A_Circumflex,
                     Key_Lc_A_Tilde,
                     Key_Lc_A_Diaeresis,
                     Key_Lc_A_Ring,
                     Key_Lc_Ae,
                     Key_Lc_C_Cedilla,
                     Key_Lc_E_Grave,
                     Key_Lc_E_Acute,
                     Key_Lc_E_Circumflex,
                     Key_Lc_E_Diaeresis,
                     Key_Lc_I_Grave,
                     Key_Lc_I_Acute,
                     Key_Lc_I_Circumflex,
                     Key_Lc_I_Diaeresis,
                     Key_Lc_Eth,
                     Key_Lc_N_Tilde,
                     Key_Lc_O_Grave,
                     Key_Lc_O_Acute,
                     Key_Lc_O_Circumflex,
                     Key_Lc_O_Tilde,
                     Key_Lc_O_Diaeresis,
                     Key_Division,
                     Key_Lc_O_Slash,
                     Key_Lc_U_Grave,
                     Key_Lc_U_Acute,
                     Key_Lc_U_Circumflex,
                     Key_Lc_U_Diaeresis,
                     Key_Lc_Y_Acute,
                     Key_Lc_Thorn,
                     Key_Lc_Y_Diaeresis,
                     Key_A_Ogonek,
                     Key_Breve,
                     Key_L_Stroke,
                     Key_L_Caron,
                     Key_S_Acute,
                     Key_S_Caron,
                     Key_S_Cedilla,
                     Key_T_Caron,
                     Key_Z_Acute,
                     Key_Z_Caron,
                     Key_Z_Above_Dot,
                     Key_Lc_A_Ogonek,
                     Key_Ogonek,
                     Key_Lc_L_Stroke,
                     Key_Lc_L_Caron,
                     Key_Lc_S_Acute,
                     Key_Lc_Caron,
                     Key_Lc_S_Caron,
                     Key_Lc_S_Cedilla,
                     Key_Lc_T_Caron,
                     Key_Lc_Z_Acute,
                     Key_Double_Acute,
                     Key_Lc_Z_Caron,
                     Key_Lc_Z_Above_Dot,
                     Key_R_Acute,
                     Key_A_Breve,
                     Key_L_Acute,
                     Key_C_Acute,
                     Key_C_Caron,
                     Key_E_Ogonek,
                     Key_E_Caron,
                     Key_D_Caron,
                     Key_D_Stroke,
                     Key_N_Acute,
                     Key_N_Caron,
                     Key_O_Double_Acute,
                     Key_R_Caron,
                     Key_U_Ring,
                     Key_U_Double_Acute,
                     Key_T_Cedilla,
                     Key_Lc_R_Acute,
                     Key_Lc_A_Breve,
                     Key_Lc_L_Acute,
                     Key_Lc_C_Acute,
                     Key_Lc_C_Caron,
                     Key_Lc_E_Ogonek,
                     Key_Lc_E_Caron,
                     Key_Lc_D_Caron,
                     Key_Lc_D_Stroke,
                     Key_Lc_N_Acute,
                     Key_Lc_N_Caron,
                     Key_Lc_O_Double_Acute,
                     Key_Lc_R_Caron,
                     Key_Lc_U_Ring,
                     Key_Lc_U_Double_Acute,
                     Key_Lc_T_Cedilla,
                     Key_Above_Dot,
                     Key_H_Stroke,
                     Key_H_Circumflex,
                     Key_I_Above_Dot,
                     Key_G_Breve,
                     Key_J_Circumflex,
                     Key_Lc_H_Stroke,
                     Key_Lc_H_Circumflex,
                     Key_Lc_I_Dotless,
                     Key_Lc_G_Breve,
                     Key_Lc_J_Circumflex,
                     Key_C_Above_Dot,
                     Key_C_Circumflex,
                     Key_G_Above_Dot,
                     Key_G_Circumflex,
                     Key_U_Breve,
                     Key_S_Circumflex,
                     Key_Lc_C_Above_Dot,
                     Key_Lc_C_Circumflex,
                     Key_Lc_G_Above_Dot,
                     Key_Lc_G_Circumflex,
                     Key_Lc_U_Breve,
                     Key_Lc_S_Circumflex,
                     Key_Kra,
                     Key_R_Cedilla,
                     Key_I_Tilde,
                     Key_L_Cedilla,
                     Key_E_Macron,
                     Key_G_Cedilla,
                     Key_T_Slash,
                     Key_Lc_R_Cedilla,
                     Key_Lc_I_Tilde,
                     Key_Lc_L_Cedilla,
                     Key_Lc_E_Macron,
                     Key_Lc_G_Cedilla,
                     Key_Lc_T_Slash,
                     Key_Eng,
                     Key_Lc_Eng,
                     Key_A_Macron,
                     Key_I_Ogonek,
                     Key_E_Above_Dot,
                     Key_I_Macron,
                     Key_N_Cedilla,
                     Key_O_Macron,
                     Key_K_Cedilla,
                     Key_U_Ogonek,
                     Key_U_Tilde,
                     Key_U_Macron,
                     Key_Lc_A_Macron,
                     Key_Lc_I_Ogonek,
                     Key_Lc_E_Above_Dot,
                     Key_Lc_I_Macron,
                     Key_Lc_N_Cedilla,
                     Key_Lc_O_Macron,
                     Key_Lc_K_Cedilla,
                     Key_Lc_U_Ogonek,
                     Key_Lc_U_Tilde,
                     Key_Lc_U_Macron,
                     Key_Overline,
                     Key_Kana_Full_Stop,
                     Key_Kana_Opening_Bracket,
                     Key_Kana_Closing_Bracket,
                     Key_Kana_Comma,
                     Key_Kana_Conjunctive,
                     Key_Kana_Wo,
                     Key_Kana_Lc_A,
                     Key_Kana_Lc_I,
                     Key_Kana_Lc_U,
                     Key_Kana_Lc_E,
                     Key_Kana_Lc_O,
                     Key_Kana_Lc_Ya,
                     Key_Kana_Lc_Yu,
                     Key_Kana_Lc_Yo,
                     Key_Kana_Lc_Tsu,
                     Key_Prolonged_Sound,
                     Key_Kana_A,
                     Key_Kana_I,
                     Key_Kana_U,
                     Key_Kana_E,
                     Key_Kana_O,
                     Key_Kana_Ka,
                     Key_Kana_Ki,
                     Key_Kana_Ku,
                     Key_Kana_Ke,
                     Key_Kana_Ko,
                     Key_Kana_Sa,
                     Key_Kana_Shi,
                     Key_Kana_Su,
                     Key_Kana_Se,
                     Key_Kana_So,
                     Key_Kana_Ta,
                     Key_Kana_Chi,
                     Key_Kana_Tsu,
                     Key_Kana_Te,
                     Key_Kana_To,
                     Key_Kana_Na,
                     Key_Kana_Ni,
                     Key_Kana_Nu,
                     Key_Kana_Ne,
                     Key_Kana_No,
                     Key_Kana_Ha,
                     Key_Kana_Hi,
                     Key_Kana_Fu,
                     Key_Kana_He,
                     Key_Kana_Ho,
                     Key_Kana_Ma,
                     Key_Kana_Mi,
                     Key_Kana_Mu,
                     Key_Kana_Me,
                     Key_Kana_Mo,
                     Key_Kana_Ya,
                     Key_Kana_Yu,
                     Key_Kana_Yo,
                     Key_Kana_Ra,
                     Key_Kana_Ri,
                     Key_Kana_Ru,
                     Key_Kana_Re,
                     Key_Kana_Ro,
                     Key_Kana_Wa,
                     Key_Kana_N,
                     Key_Voiced_Sound,
                     Key_Semi_Voiced_Sound,
                     Key_Arabic_Comma,
                     Key_Arabic_Semicolon,
                     Key_Arabic_Question_Mark,
                     Key_Arabic_Hamza,
                     Key_Arabic_Madda_On_Alef,
                     Key_Arabic_Hamza_On_Alef,
                     Key_Arabic_Hamza_On_Waw,
                     Key_Arabic_Hamza_Under_Alef,
                     Key_Arabic_Hamza_On_Yeh,
                     Key_Arabic_Alef,
                     Key_Arabic_Beh,
                     Key_Arabic_Teh_Marbuta,
                     Key_Arabic_Teh,
                     Key_Arabic_Theh,
                     Key_Arabic_Jeem,
                     Key_Arabic_Hah,
                     Key_Arabic_Khah,
                     Key_Arabic_Dal,
                     Key_Arabic_Thal,
                     Key_Arabic_Ra,
                     Key_Arabic_Zain,
                     Key_Arabic_Seen,
                     Key_Arabic_Sheen,
                     Key_Arabic_Sad,
                     Key_Arabic_Dad,
                     Key_Arabic_Tah,
                     Key_Arabic_Zah,
                     Key_Arabic_Ain,
                     Key_Arabic_Ghain,
                     Key_Arabic_Tatweel,
                     Key_Arabic_Feh,
                     Key_Arabic_Qaf,
                     Key_Arabic_Kaf,
                     Key_Arabic_Lam,
                     Key_Arabic_Meem,
                     Key_Arabic_Noon,
                     Key_Arabic_Ha,
                     Key_Arabic_Waw,
                     Key_Arabic_Alef_Maksura,
                     Key_Arabic_Yeh,
                     Key_Arabic_Fatha_Tan,
                     Key_Arabic_Damma_Tan,
                     Key_Arabic_Kasra_Tan,
                     Key_Arabic_Fatha,
                     Key_Arabic_Damma,
                     Key_Arabic_Kasra,
                     Key_Arabic_Shadda,
                     Key_Arabic_Sukun,
                     Key_Serbian_Lc_Dje,
                     Key_Macedonia_Lc_Gje,
                     Key_Cyrillic_Lc_Io,
                     Key_Ukrainian_Lc_Ie,
                     Key_Macedonia_Lc_Dse,
                     Key_Ukrainian_Lc_I,
                     Key_Ukrainian_Lc_Yi,
                     Key_Cyrillic_Lc_Je,
                     Key_Cyrillic_Lc_Lje,
                     Key_Cyrillic_Lc_Nje,
                     Key_Serbian_Lc_Tshe,
                     Key_Macedonia_Lc_Kje,
                     Key_Byelorussian_Lc_Shortu,
                     Key_Cyrillic_Lc_Dzhe,
                     Key_Numero_Sign,
                     Key_Serbian_Dje,
                     Key_Macedonia_Gje,
                     Key_Cyrillic_Io,
                     Key_Ukrainian_Ie,
                     Key_Macedonia_Dse,
                     Key_Ukrainian_I,
                     Key_Ukrainian_Yi,
                     Key_Cyrillic_Je,
                     Key_Cyrillic_Lje,
                     Key_Cyrillic_Nje,
                     Key_Serbian_Tshe,
                     Key_Macedonia_Kje,
                     Key_Byelorussian_Shortu,
                     Key_Cyrillic_Dzhe,
                     Key_Cyrillic_Lc_Yu,
                     Key_Cyrillic_Lc_A,
                     Key_Cyrillic_Lc_Be,
                     Key_Cyrillic_Lc_Tse,
                     Key_Cyrillic_Lc_De,
                     Key_Cyrillic_Lc_Ie,
                     Key_Cyrillic_Lc_Ef,
                     Key_Cyrillic_Lc_Ghe,
                     Key_Cyrillic_Lc_Ha,
                     Key_Cyrillic_Lc_I,
                     Key_Cyrillic_Lc_Shorti,
                     Key_Cyrillic_Lc_Ka,
                     Key_Cyrillic_Lc_El,
                     Key_Cyrillic_Lc_Em,
                     Key_Cyrillic_Lc_En,
                     Key_Cyrillic_Lc_O,
                     Key_Cyrillic_Lc_Pe,
                     Key_Cyrillic_Lc_Ya,
                     Key_Cyrillic_Lc_Er,
                     Key_Cyrillic_Lc_Es,
                     Key_Cyrillic_Lc_Te,
                     Key_Cyrillic_Lc_U,
                     Key_Cyrillic_Lc_Zhe,
                     Key_Cyrillic_Lc_Ve,
                     Key_Cyrillic_Lc_Softsign,
                     Key_Cyrillic_Lc_Yeru,
                     Key_Cyrillic_Lc_Ze,
                     Key_Cyrillic_Lc_Sha,
                     Key_Cyrillic_Lc_E,
                     Key_Cyrillic_Lc_Shcha,
                     Key_Cyrillic_Lc_Che,
                     Key_Cyrillic_Lc_Hardsign,
                     Key_Cyrillic_Yu,
                     Key_Cyrillic_A,
                     Key_Cyrillic_Be,
                     Key_Cyrillic_Tse,
                     Key_Cyrillic_De,
                     Key_Cyrillic_Ie,
                     Key_Cyrillic_Ef,
                     Key_Cyrillic_Ghe,
                     Key_Cyrillic_Ha,
                     Key_Cyrillic_I,
                     Key_Cyrillic_Shorti,
                     Key_Cyrillic_Ka,
                     Key_Cyrillic_El,
                     Key_Cyrillic_Em,
                     Key_Cyrillic_En,
                     Key_Cyrillic_O,
                     Key_Cyrillic_Pe,
                     Key_Cyrillic_Ya,
                     Key_Cyrillic_Er,
                     Key_Cyrillic_Es,
                     Key_Cyrillic_Te,
                     Key_Cyrillic_U,
                     Key_Cyrillic_Zhe,
                     Key_Cyrillic_Ve,
                     Key_Cyrillic_Softsign,
                     Key_Cyrillic_Yeru,
                     Key_Cyrillic_Ze,
                     Key_Cyrillic_Sha,
                     Key_Cyrillic_E,
                     Key_Cyrillic_Shcha,
                     Key_Cyrillic_Che,
                     Key_Cyrillic_Hardsign,
                     Key_Greek_Alpha_Accent,
                     Key_Greek_Epsilon_Accent,
                     Key_Greek_Eta_Accent,
                     Key_Greek_Iota_Accent,
                     Key_Greek_Iota_Diaeresis,
                     Key_Greek_Omicron_Accent,
                     Key_Greek_Upsilon_Accent,
                     Key_Greek_Upsilon_Dieresis,
                     Key_Greek_Omega_Accent,
                     Key_Greek_Accent_Dieresis,
                     Key_Greek_Horiz_Bar,
                     Key_Greek_Lc_Alpha_Accent,
                     Key_Greek_Lc_Epsilon_Accent,
                     Key_Greek_Lc_Eta_Accent,
                     Key_Greek_Lc_Iota_Accent,
                     Key_Greek_Lc_Iota_Dieresis,
                     Key_Greek_Lc_Iota_Accent_Dieresis,
                     Key_Greek_Lc_Omicron_Accent,
                     Key_Greek_Lc_Upsilon_Accent,
                     Key_Greek_Lc_Upsilon_Dieresis,
                     Key_Greek_Lc_Upsilon_Accent_Dieresis,
                     Key_Greek_Lc_Omega_Accent,
                     Key_Greek_Alpha,
                     Key_Greek_Beta,
                     Key_Greek_Gamma,
                     Key_Greek_Delta,
                     Key_Greek_Epsilon,
                     Key_Greek_Zeta,
                     Key_Greek_Eta,
                     Key_Greek_Theta,
                     Key_Greek_Iota,
                     Key_Greek_Kappa,
                     Key_Greek_Lambda,
                     Key_Greek_Mu,
                     Key_Greek_Nu,
                     Key_Greek_Xi,
                     Key_Greek_Omicron,
                     Key_Greek_Pi,
                     Key_Greek_Rho,
                     Key_Greek_Sigma,
                     Key_Greek_Tau,
                     Key_Greek_Upsilon,
                     Key_Greek_Phi,
                     Key_Greek_Chi,
                     Key_Greek_Psi,
                     Key_Greek_Omega,
                     Key_Greek_Lc_Alpha,
                     Key_Greek_Lc_Beta,
                     Key_Greek_Lc_Gamma,
                     Key_Greek_Lc_Delta,
                     Key_Greek_Lc_Epsilon,
                     Key_Greek_Lc_Zeta,
                     Key_Greek_Lc_Eta,
                     Key_Greek_Lc_Theta,
                     Key_Greek_Lc_Iota,
                     Key_Greek_Lc_Kappa,
                     Key_Greek_Lc_Lambda,
                     Key_Greek_Lc_Mu,
                     Key_Greek_Lc_Nu,
                     Key_Greek_Lc_Xi,
                     Key_Greek_Lc_Omicron,
                     Key_Greek_Lc_Pi,
                     Key_Greek_Lc_Rho,
                     Key_Greek_Lc_Sigma,
                     Key_Greek_Final_Small_Sigma,
                     Key_Greek_Lc_Tau,
                     Key_Greek_Lc_Upsilon,
                     Key_Greek_Lc_Phi,
                     Key_Greek_Lc_Chi,
                     Key_Greek_Lc_Psi,
                     Key_Greek_Lc_Omega,
                     Key_Left_Radical,
                     Key_Top_Left_Radical,
                     Key_Horiz_Connector,
                     Key_Top_Integral,
                     Key_Bot_Integral,
                     Key_Vert_Connector,
                     Key_Top_Left_Sq_Bracket,
                     Key_Bot_Left_Sq_Bracket,
                     Key_Top_Right_Sq_Bracket,
                     Key_Bot_Right_Sq_Bracket,
                     Key_Top_Left_Parens,
                     Key_Bot_Left_Parens,
                     Key_Top_Right_Parens,
                     Key_Bot_Right_Parens,
                     Key_Left_Middle_Curly_Brace,
                     Key_Right_Middle_Curly_Brace,
                     Key_Top_Left_Summation,
                     Key_Bot_Left_Summation,
                     Key_Top_Vert_Summation_Connector,
                     Key_Bot_Vert_Summation_Connector,
                     Key_Top_Right_Summation,
                     Key_Bot_Right_Summation,
                     Key_Right_Middle_Summation,
                     Key_Less_Than_Equal,
                     Key_Not_Equal,
                     Key_Greater_Than_Equal,
                     Key_Integral,
                     Key_Therefore,
                     Key_Variation,
                     Key_Infinity,
                     Key_Nabla,
                     Key_Approximate,
                     Key_Similar_Equal,
                     Key_If_Only_If,
                     Key_Implies,
                     Key_Identical,
                     Key_Radical,
                     Key_Included_In,
                     Key_Includes,
                     Key_Intersection,
                     Key_Union,
                     Key_Logical_And,
                     Key_Logical_Or,
                     Key_Partial_Derivative,
                     Key_Function,
                     Key_Left_Arrow,
                     Key_Up_Arrow,
                     Key_Right_Arrow,
                     Key_Down_Arrow,
                     Key_Blank,
                     Key_Solid_Diamond,
                     Key_Checker_Board,
                     Key_Ht,
                     Key_Ff,
                     Key_Cr,
                     Key_Lf,
                     Key_Nl,
                     Key_Vt,
                     Key_Low_Right_Corner,
                     Key_Up_Right_Corner,
                     Key_Up_Left_Corner,
                     Key_Low_Left_Corner,
                     Key_Crossing_Lines,
                     Key_Horiz_Line_Scan1,
                     Key_Horiz_Line_Scan3,
                     Key_Horiz_Line_Scan5,
                     Key_Horiz_Line_Scan7,
                     Key_Horiz_Line_Scan9,
                     Key_Left_T,
                     Key_Right_T,
                     Key_Bot_T,
                     Key_Top_T,
                     Key_Vert_Bar,
                     Key_Em_Space,
                     Key_En_Space,
                     Key_Em3_Space,
                     Key_Em4_Space,
                     Key_Digit_Space,
                     Key_Punct_Space,
                     Key_Thin_Space,
                     Key_Hair_Space,
                     Key_Em_Dash,
                     Key_En_Dash,
                     Key_Signif_Blank,
                     Key_Ellipsis,
                     Key_Doub_Baseline_Dot,
                     Key_One_Third,
                     Key_Two_Thirds,
                     Key_One_Fifth,
                     Key_Two_Fifths,
                     Key_Three_Fifths,
                     Key_Four_Fifths,
                     Key_One_Sixth,
                     Key_Five_Sixths,
                     Key_Care_Of,
                     Key_Fig_Dash,
                     Key_Left_Angle_Bracket,
                     Key_Decimal_Point,
                     Key_Right_Angle_Bracket,
                     Key_Marker,
                     Key_One_Eighth,
                     Key_Three_Eighths,
                     Key_Five_Eighths,
                     Key_Seven_Eighths,
                     Key_Trade_Mark,
                     Key_Signature_Mark,
                     Key_Trade_Mark_In_Circle,
                     Key_Left_Open_Triangle,
                     Key_Right_Open_Triangle,
                     Key_Em_Open_Circle,
                     Key_Em_Open_Rectangle,
                     Key_Left_Single_Quote_Mark,
                     Key_Right_Single_Quote_Mark,
                     Key_Left_Double_Quote_Mark,
                     Key_Right_Double_Quote_Mark,
                     Key_Prescription,
                     Key_Minutes,
                     Key_Seconds,
                     Key_Latin_Cross,
                     Key_Hexagram,
                     Key_Filled_Rect_Bullet,
                     Key_Filled_Left_Tri_Bullet,
                     Key_Filled_Right_Tri_Bullet,
                     Key_Em_Filled_Circle,
                     Key_Em_Filled_Rect,
                     Key_En_Open_Circ_Bullet,
                     Key_En_Open_Square_Bullet,
                     Key_Open_Rect_Bullet,
                     Key_Open_Tri_Bullet_Up,
                     Key_Open_Tri_Bullet_Down,
                     Key_Open_Star,
                     Key_En_Filled_Circ_Bullet,
                     Key_En_Filled_Sqare_Bullet,
                     Key_Filled_Tri_Bullet_Up,
                     Key_Filled_Tri_Bullet_Down,
                     Key_Left_Pointer,
                     Key_Right_Pointer,
                     Key_Club,
                     Key_Diamond,
                     Key_Heart,
                     Key_Maltese_Cross,
                     Key_Dagger,
                     Key_Double_Dagger,
                     Key_Check_Mark,
                     Key_Ballot_Cross,
                     Key_Musical_Sharp,
                     Key_Musical_Flat,
                     Key_Male_Symbol,
                     Key_Female_Symbol,
                     Key_Telephone,
                     Key_Telephone_Recorder,
                     Key_Phonograph_Copyright,
                     Key_Caret,
                     Key_Single_Low_Quote_Mark,
                     Key_Double_Low_Quote_Mark,
                     Key_Cursor,
                     Key_Left_Caret,
                     Key_Right_Caret,
                     Key_Down_Caret,
                     Key_Up_Caret,
                     Key_Over_Bar,
                     Key_Down_Tack,
                     Key_Up_Shoe,
                     Key_Down_Stile,
                     Key_Under_Bar,
                     Key_Jot,
                     Key_Quad,
                     Key_Up_Tack,
                     Key_Circle,
                     Key_Up_Stile,
                     Key_Down_Shoe,
                     Key_Right_Shoe,
                     Key_Left_Shoe,
                     Key_Left_Tack,
                     Key_Right_Tack,
                     Key_Hebrew_Double_Low_Line,
                     Key_Hebrew_Aleph,
                     Key_Hebrew_Bet,
                     Key_Hebrew_Gimel,
                     Key_Hebrew_Dalet,
                     Key_Hebrew_He,
                     Key_Hebrew_Waw,
                     Key_Hebrew_Zain,
                     Key_Hebrew_Chet,
                     Key_Hebrew_Tet,
                     Key_Hebrew_Yod,
                     Key_Hebrew_Final_Kaph,
                     Key_Hebrew_Kaph,
                     Key_Hebrew_Lamed,
                     Key_Hebrew_Final_Mem,
                     Key_Hebrew_Mem,
                     Key_Hebrew_Final_Nun,
                     Key_Hebrew_Nun,
                     Key_Hebrew_Samech,
                     Key_Hebrew_Ayin,
                     Key_Hebrew_Final_Pe,
                     Key_Hebrew_Pe,
                     Key_Hebrew_Final_Zade,
                     Key_Hebrew_Zade,
                     Key_Hebrew_Qoph,
                     Key_Hebrew_Resh,
                     Key_Hebrew_Shin,
                     Key_Hebrew_Taw,
                     Key_Backspace, -- back space, back char
                     Key_Tab,
                     Key_Line_Feed, -- Linefeed, LF
                     Key_Clear,
                     Key_Return, -- Return, enter
                     Key_Pause, -- Pause, hold
                     Key_Scroll_Lock,
                     Key_Escape,
                     Key_Multi_Key,
                     Key_Kanji,  -- Kanji, Kanji convert
                     Key_Muhenkan,  -- Cancel Conversion
                     Key_Henkan_Mode,  -- Start/Stop Conversion
                     Key_Romaji,  -- to Romaji
                     Key_Hiragana,  -- to Hiragana
                     Key_Katakana,  -- to Katakana
                     Key_Hiragana_Katakana,  -- Hiragana/Katakana toggle
                     Key_Zenkaku,  -- to Zenkaku
                     Key_Hankaku,  -- to Hankaku
                     Key_Zenkaku_Hankaku,  -- Zenkaku/Hankaku toggle
                     Key_Touroku,  -- Add to Dictionary
                     Key_Massyo,  -- Delete from Dictionary
                     Key_Kana_Lock,  -- Kana Lock
                     Key_Kana_Shift,  -- Kana Shift
                     Key_Eisu_Shift,  -- Alphanumeric Shift
                     Key_Eisu_Toggle,  -- Alphanumeric toggle
                     Key_Home,
                     Key_Left,  -- Move left, left arrow
                     Key_Up,  -- Move up, up arrow
                     Key_Right,  -- Move right, right arrow
                     Key_Down,  -- Move down, down arrow
                     Key_Prior,  -- Prior, previous
                     Key_Next,  -- Next
                     Key_End,  -- EOL
                     Key_Begin,  -- BOL
                     Key_Select,  -- Select, mark
                     Key_Print,
                     Key_Execute,  -- Execute, run, do
                     Key_Insert,  -- Insert, insert here
                     Key_Undo,  -- Undo, oops
                     Key_Redo,  -- redo, again
                     Key_Menu,
                     Key_Find,  -- Find, search
                     Key_Cancel,  -- Cancel, stop, abort, exit
                     Key_Help,  -- Help, ?
                     Key_Break,
                     Key_Mode_Switch,  -- Character set switch
                     Key_Num_Lock,
                     Keypad_Space, -- space
                     Keypad_Tab,
                     Keypad_Enter, -- enter
                     Keypad_F1, -- PF1, Keypad_A, ...
                     Keypad_F2,
                     Keypad_F3,
                     Keypad_F4,
                     Keypad_Multiply,
                     Keypad_Add,
                     Keypad_Separator, -- separator, often comma
                     Keypad_Subtract,
                     Keypad_Decimal,
                     Keypad_Divide,
                     Keypad_0,
                     Keypad_1,
                     Keypad_2,
                     Keypad_3,
                     Keypad_4,
                     Keypad_5,
                     Keypad_6,
                     Keypad_7,
                     Keypad_8,
                     Keypad_9,
                     Keypad_Equal, -- equals
                     Key_F1,
                     Key_F2,
                     Key_F3,
                     Key_F4,
                     Key_F5,
                     Key_F6,
                     Key_F7,
                     Key_F8,
                     Key_F9,
                     Key_F10,
                     Key_F11,
                     Key_F12,
                     Key_F13,
                     Key_F14,
                     Key_F15,
                     Key_F16,
                     Key_F17,
                     Key_F18,
                     Key_F19,
                     Key_F20,
                     Key_F21,
                     Key_F22,
                     Key_F23,
                     Key_F24,
                     Key_F25,
                     Key_F26,
                     Key_F27,
                     Key_F28,
                     Key_F29,
                     Key_F30,
                     Key_F31,
                     Key_F32,
                     Key_F33,
                     Key_F34,
                     Key_F35,
                     Key_Shift_L,  -- Left shift
                     Key_Shift_R,  -- Right shift
                     Key_Control_L,  -- Left control
                     Key_Control_R,  -- Right control
                     Key_Caps_Lock,  -- Caps lock
                     Key_Shift_Lock,  -- Shift lock
                     Key_Meta_L,  -- Left meta
                     Key_Meta_R,  -- Right meta
                     Key_Alt_L,  -- Left alt
                     Key_Alt_R,  -- Right alt
                     Key_Super_L,  -- Left super
                     Key_Super_R,  -- Right super
                     Key_Hyper_L,  -- Left hyper
                     Key_Hyper_R,  -- Right hyper
                     Key_Delete, -- Delete, rubout
                     Key_Void_Symbol ) ;   -- void symbol

    for Symbol'size use 32 ;

    for Symbol use (
    No_Symbol        => 16#0#,


--  Latin 1
--  Byte 3 = 0


    Key_Space             => 16#0_20#,
    Key_Exclam            => 16#0_21#,
    Key_Quoted_Bl         => 16#0_22#,
    Key_Number_Sign       => 16#0_23#,
    Key_Dollar            => 16#0_24#,
    Key_Percent           => 16#0_25#,
    Key_Ampersand         => 16#0_26#,
    Key_Apostrophe        => 16#0_27#,
    Key_Paren_Left        => 16#0_28#,
    Key_Paren_Right       => 16#0_29#,
    Key_Asterisk          => 16#0_2A#,
    Key_Plus              => 16#0_2B#,
    Key_Comma             => 16#0_2C#,
    Key_Minus             => 16#0_2D#,
    Key_Period            => 16#0_2E#,
    Key_Slash             => 16#0_2F#,
    Key_0                 => 16#0_30#,
    Key_1                 => 16#0_31#,
    Key_2                 => 16#0_32#,
    Key_3                 => 16#0_33#,
    Key_4                 => 16#0_34#,
    Key_5                 => 16#0_35#,
    Key_6                 => 16#0_36#,
    Key_7                 => 16#0_37#,
    Key_8                 => 16#0_38#,
    Key_9                 => 16#0_39#,
    Key_Colon             => 16#0_3A#,
    Key_Semi_Colon        => 16#0_3B#,
    Key_Less              => 16#0_3C#,
    Key_Equal             => 16#0_3D#,
    Key_Greater           => 16#0_3E#,
    Key_Question          => 16#0_3F#,
    Key_At                => 16#0_40#,
    Key_A                 => 16#0_41#,
    Key_B                 => 16#0_42#,
    Key_C                 => 16#0_43#,
    Key_D                 => 16#0_44#,
    Key_E                 => 16#0_45#,
    Key_F                 => 16#0_46#,
    Key_G                 => 16#0_47#,
    Key_H                 => 16#0_48#,
    Key_I                 => 16#0_49#,
    Key_J                 => 16#0_4A#,
    Key_K                 => 16#0_4B#,
    Key_L                 => 16#0_4C#,
    Key_M                 => 16#0_4D#,
    Key_N                 => 16#0_4E#,
    Key_O                 => 16#0_4F#,
    Key_P                 => 16#0_50#,
    Key_Q                 => 16#0_51#,
    Key_R                 => 16#0_52#,
    Key_S                 => 16#0_53#,
    Key_T                 => 16#0_54#,
    Key_U                 => 16#0_55#,
    Key_V                 => 16#0_56#,
    Key_W                 => 16#0_57#,
    Key_X                 => 16#0_58#,
    Key_Y                 => 16#0_59#,
    Key_Z                 => 16#0_5A#,
    Key_Bracket_Left      => 16#0_5B#,
    Key_Back_Slash        => 16#0_5C#,
    Key_Bracket_Right     => 16#0_5D#,
    Key_Ascii_Circum      => 16#0_5E#,
    Key_Underscore        => 16#0_5F#,
    Key_Grave             => 16#0_60#,
    Key_Lc_A              => 16#0_61#,
    Key_Lc_B              => 16#0_62#,
    Key_Lc_C              => 16#0_63#,
    Key_Lc_D              => 16#0_64#,
    Key_Lc_E              => 16#0_65#,
    Key_Lc_F              => 16#0_66#,
    Key_Lc_G              => 16#0_67#,
    Key_Lc_H              => 16#0_68#,
    Key_Lc_I              => 16#0_69#,
    Key_Lc_J              => 16#0_6A#,
    Key_Lc_K              => 16#0_6B#,
    Key_Lc_L              => 16#0_6C#,
    Key_Lc_M              => 16#0_6D#,
    Key_Lc_N              => 16#0_6E#,
    Key_Lc_O              => 16#0_6F#,
    Key_Lc_P              => 16#0_70#,
    Key_Lc_Q              => 16#0_71#,
    Key_Lc_R              => 16#0_72#,
    Key_Lc_S              => 16#0_73#,
    Key_Lc_T              => 16#0_74#,
    Key_Lc_U              => 16#0_75#,
    Key_Lc_V              => 16#0_76#,
    Key_Lc_W              => 16#0_77#,
    Key_Lc_X              => 16#0_78#,
    Key_Lc_Y              => 16#0_79#,
    Key_Lc_Z              => 16#0_7A#,
    Key_Brace_Left        => 16#0_7B#,
    Key_Bar               => 16#0_7C#,
    Key_Brace_Right       => 16#0_7D#,
    Key_Ascii_Tilde       => 16#0_7E#,
                                                         
    Key_No_Break_Space    => 16#0_A0#,
    Key_Exclam_Down       => 16#0_A1#,
    Key_Cent              => 16#0_A2#,
    Key_Sterling          => 16#0_A3#,
    Key_Currency          => 16#0_A4#,
    Key_Yen               => 16#0_A5#,
    Key_Broken_Bar        => 16#0_A6#,
    Key_Section           => 16#0_A7#,
    Key_Diaeresis         => 16#0_A8#,
    Key_Copyright         => 16#0_A9#,
    Key_Ord_Feminine      => 16#0_AA#,
    Key_Guillemot_Left    => 16#0_AB#,    -- left angle quotation mark
    Key_Notsign           => 16#0_AC#,
    Key_Hyphen            => 16#0_AD#,
    Key_Registered        => 16#0_AE#,
    Key_Macron            => 16#0_AF#,
    Key_Degree            => 16#0_B0#,
    Key_Plus_Minus        => 16#0_B1#,
    Key_Two_Superior      => 16#0_B2#,
    Key_Three_Superior    => 16#0_B3#,
    Key_Acute             => 16#0_B4#,
    Key_Mu                => 16#0_B5#,
    Key_Paragraph         => 16#0_B6#,
    Key_Period_Centered   => 16#0_B7#,
    Key_Cedilla           => 16#0_B8#,
    Key_One_Superior      => 16#0_B9#,
    Key_Masculine         => 16#0_BA#,
    Key_Guillemot_Right   => 16#0_BB#,    -- right angle quotation mark
    Key_One_Quarter       => 16#0_BC#,
    Key_One_Half          => 16#0_BD#,
    Key_Three_Quarters    => 16#0_BE#,
    Key_Question_Down     => 16#0_BF#,
    Key_A_Grave           => 16#0_C0#,
    Key_A_Acute           => 16#0_C1#,
    Key_A_Circumflex      => 16#0_C2#,
    Key_A_Tilde           => 16#0_C3#,
    Key_A_Diaeresis       => 16#0_C4#,
    Key_A_Ring            => 16#0_C5#,
    Key_Ae                => 16#0_C6#,
    Key_C_Cedilla         => 16#0_C7#,
    Key_E_Grave           => 16#0_C8#,
    Key_E_Acute           => 16#0_C9#,
    Key_E_Circumflex      => 16#0_CA#,
    Key_E_Diaeresis       => 16#0_CB#,
    Key_I_Grave           => 16#0_CC#,
    Key_I_Acute           => 16#0_CD#,
    Key_I_Circumflex      => 16#0_CE#,
    Key_I_Diaeresis       => 16#0_CF#,
    Key_Eth               => 16#0_D0#,
    Key_N_Tilde           => 16#0_D1#,
    Key_O_Grave           => 16#0_D2#,
    Key_O_Acute           => 16#0_D3#,
    Key_O_Circumflex      => 16#0_D4#,
    Key_O_Tilde           => 16#0_D5#,
    Key_O_Diaeresis       => 16#0_D6#,
    Key_Multiply          => 16#0_D7#,
    Key_O_Oblique         => 16#0_D8#,
    Key_U_Grave           => 16#0_D9#,
    Key_U_Acute           => 16#0_DA#,
    Key_U_Circumflex      => 16#0_DB#,
    Key_U_Diaeresis       => 16#0_DC#,
    Key_Y_Acute           => 16#0_DD#,
    Key_Thorn             => 16#0_DE#,
    Key_Lc_S_Sharp        => 16#0_DF#,
    Key_Lc_A_Grave        => 16#0_E0#,
    Key_Lc_A_Acute        => 16#0_E1#,
    Key_Lc_A_Circumflex   => 16#0_E2#,
    Key_Lc_A_Tilde        => 16#0_E3#,
    Key_Lc_A_Diaeresis    => 16#0_E4#,
    Key_Lc_A_Ring         => 16#0_E5#,
    Key_Lc_Ae             => 16#0_E6#,
    Key_Lc_C_Cedilla      => 16#0_E7#,
    Key_Lc_E_Grave        => 16#0_E8#,
    Key_Lc_E_Acute        => 16#0_E9#,
    Key_Lc_E_Circumflex   => 16#0_EA#,
    Key_Lc_E_Diaeresis    => 16#0_EB#,
    Key_Lc_I_Grave        => 16#0_EC#,
    Key_Lc_I_Acute        => 16#0_ED#,
    Key_Lc_I_Circumflex   => 16#0_EE#,
    Key_Lc_I_Diaeresis    => 16#0_EF#,
    Key_Lc_Eth            => 16#0_F0#,
    Key_Lc_N_Tilde        => 16#0_F1#,
    Key_Lc_O_Grave        => 16#0_F2#,
    Key_Lc_O_Acute        => 16#0_F3#,
    Key_Lc_O_Circumflex   => 16#0_F4#,
    Key_Lc_O_Tilde        => 16#0_F5#,
    Key_Lc_O_Diaeresis    => 16#0_F6#,
    Key_Division          => 16#0_F7#,
    Key_Lc_O_Slash        => 16#0_F8#,
    Key_Lc_U_Grave        => 16#0_F9#,
    Key_Lc_U_Acute        => 16#0_FA#,
    Key_Lc_U_Circumflex   => 16#0_FB#,
    Key_Lc_U_Diaeresis    => 16#0_FC#,
    Key_Lc_Y_Acute        => 16#0_FD#,
    Key_Lc_Thorn          => 16#0_FE#,
    Key_Lc_Y_Diaeresis    => 16#0_FF#,



--   Latin 2
--   Byte 3 = 1


    Key_A_Ogonek          => 16#1_A1#,
    Key_Breve             => 16#1_A2#,
    Key_L_Stroke          => 16#1_A3#,
    Key_L_Caron           => 16#1_A5#,
    Key_S_Acute           => 16#1_A6#,
    Key_S_Caron           => 16#1_A9#,
    Key_S_Cedilla         => 16#1_AA#,
    Key_T_Caron           => 16#1_AB#,
    Key_Z_Acute           => 16#1_AC#,
    Key_Z_Caron           => 16#1_AE#,
    Key_Z_Above_Dot       => 16#1_AF#,
    Key_Lc_A_Ogonek       => 16#1_B1#,
    Key_Ogonek            => 16#1_B2#,
    Key_Lc_L_Stroke       => 16#1_B3#,
    Key_Lc_L_Caron        => 16#1_B5#,
    Key_Lc_S_Acute        => 16#1_B6#,
    Key_Lc_Caron          => 16#1_B7#,
    Key_Lc_S_Caron        => 16#1_B9#,
    Key_Lc_S_Cedilla      => 16#1_BA#,
    Key_Lc_T_Caron        => 16#1_BB#,
    Key_Lc_Z_Acute        => 16#1_BC#,
    Key_Double_Acute      => 16#1_BD#,
    Key_Lc_Z_Caron        => 16#1_BE#,
    Key_Lc_Z_Above_Dot    => 16#1_BF#,
    Key_R_Acute           => 16#1_C0#,
    Key_A_Breve           => 16#1_C3#,
    Key_L_Acute           => 16#1_C5#,
    Key_C_Acute           => 16#1_C6#,
    Key_C_Caron           => 16#1_C8#,
    Key_E_Ogonek          => 16#1_CA#,
    Key_E_Caron           => 16#1_CC#,
    Key_D_Caron           => 16#1_CF#,
    Key_D_Stroke          => 16#1_D0#,
    Key_N_Acute           => 16#1_D1#,
    Key_N_Caron           => 16#1_D2#,
    Key_O_Double_Acute    => 16#1_D5#,
    Key_R_Caron           => 16#1_D8#,
    Key_U_Ring            => 16#1_D9#,
    Key_U_Double_Acute    => 16#1_DB#,
    Key_T_Cedilla         => 16#1_DE#,
    Key_Lc_R_Acute        => 16#1_E0#,
    Key_Lc_A_Breve        => 16#1_E3#,
    Key_Lc_L_Acute        => 16#1_E5#,
    Key_Lc_C_Acute        => 16#1_E6#,
    Key_Lc_C_Caron        => 16#1_E8#,
    Key_Lc_E_Ogonek       => 16#1_EA#,
    Key_Lc_E_Caron        => 16#1_EC#,
    Key_Lc_D_Caron        => 16#1_EF#,
    Key_Lc_D_Stroke       => 16#1_F0#,
    Key_Lc_N_Acute        => 16#1_F1#,
    Key_Lc_N_Caron        => 16#1_F2#,
    Key_Lc_O_Double_Acute => 16#1_F5#,
    Key_Lc_R_Caron        => 16#1_F8#,
    Key_Lc_U_Ring         => 16#1_F9#,
    Key_Lc_U_Double_Acute => 16#1_FB#,
    Key_Lc_T_Cedilla      => 16#1_FE#,
    Key_Above_Dot         => 16#1_FF#,



--   Latin 3
--   Byte 3 = 2


    Key_H_Stroke          => 16#2_A1#,
    Key_H_Circumflex      => 16#2_A6#,
    Key_I_Above_Dot       => 16#2_A9#,
    Key_G_Breve           => 16#2_AB#,
    Key_J_Circumflex      => 16#2_AC#,
    Key_Lc_H_Stroke       => 16#2_B1#,
    Key_Lc_H_Circumflex   => 16#2_B6#,
    Key_Lc_I_Dotless      => 16#2_B9#,
    Key_Lc_G_Breve        => 16#2_BB#,
    Key_Lc_J_Circumflex   => 16#2_BC#,
    Key_C_Above_Dot       => 16#2_C5#,
    Key_C_Circumflex      => 16#2_C6#,
    Key_G_Above_Dot       => 16#2_D5#,
    Key_G_Circumflex      => 16#2_D8#,
    Key_U_Breve           => 16#2_DD#,
    Key_S_Circumflex      => 16#2_DE#,
    Key_Lc_C_Above_Dot    => 16#2_E5#,
    Key_Lc_C_Circumflex   => 16#2_E6#,
    Key_Lc_G_Above_Dot    => 16#2_F5#,
    Key_Lc_G_Circumflex   => 16#2_F8#,
    Key_Lc_U_Breve        => 16#2_FD#,
    Key_Lc_S_Circumflex   => 16#2_FE#,




--   Latin 4
--   Byte 3 = 3


    Key_Kra               => 16#3_A2#,
    Key_R_Cedilla         => 16#3_A3#,
    Key_I_Tilde           => 16#3_A5#,
    Key_L_Cedilla         => 16#3_A6#,
    Key_E_Macron          => 16#3_AA#,
    Key_G_Cedilla         => 16#3_AB#,
    Key_T_Slash           => 16#3_AC#,
    Key_Lc_R_Cedilla      => 16#3_B3#,
    Key_Lc_I_Tilde        => 16#3_B5#,
    Key_Lc_L_Cedilla      => 16#3_B6#,
    Key_Lc_E_Macron       => 16#3_BA#,
    Key_Lc_G_Cedilla      => 16#3_BB#,
    Key_Lc_T_Slash        => 16#3_BC#,
    Key_Eng               => 16#3_BD#,
    Key_Lc_Eng            => 16#3_BF#,
    Key_A_Macron          => 16#3_C0#,
    Key_I_Ogonek          => 16#3_C7#,
    Key_E_Above_Dot       => 16#3_CC#,
    Key_I_Macron          => 16#3_CF#,
    Key_N_Cedilla         => 16#3_D1#,
    Key_O_Macron          => 16#3_D2#,
    Key_K_Cedilla         => 16#3_D3#,
    Key_U_Ogonek          => 16#3_D9#,
    Key_U_Tilde           => 16#3_DD#,
    Key_U_Macron          => 16#3_DE#,
    Key_Lc_A_Macron       => 16#3_E0#,
    Key_Lc_I_Ogonek       => 16#3_E7#,
    Key_Lc_E_Above_Dot    => 16#3_EC#,
    Key_Lc_I_Macron       => 16#3_EF#,
    Key_Lc_N_Cedilla      => 16#3_F1#,
    Key_Lc_O_Macron       => 16#3_F2#,
    Key_Lc_K_Cedilla      => 16#3_F3#,
    Key_Lc_U_Ogonek       => 16#3_F9#,
    Key_Lc_U_Tilde        => 16#3_FD#,
    Key_Lc_U_Macron       => 16#3_FE#,


-- Katakana
-- Byte 3 = 4



    Key_Overline             => 16#4_7E#,
    Key_Kana_Full_Stop       => 16#4_A1#,
    Key_Kana_Opening_Bracket => 16#4_A2#,
    Key_Kana_Closing_Bracket => 16#4_A3#,
    Key_Kana_Comma           => 16#4_A4#,
    Key_Kana_Conjunctive     => 16#4_A5#,
    Key_Kana_Wo              => 16#4_A6#,
    Key_Kana_Lc_A            => 16#4_A7#,
    Key_Kana_Lc_I            => 16#4_A8#,
    Key_Kana_Lc_U            => 16#4_A9#,
    Key_Kana_Lc_E            => 16#4_AA#,
    Key_Kana_Lc_O            => 16#4_AB#,
    Key_Kana_Lc_Ya           => 16#4_AC#,
    Key_Kana_Lc_Yu           => 16#4_AD#,
    Key_Kana_Lc_Yo           => 16#4_AE#,
    Key_Kana_Lc_Tsu          => 16#4_AF#,
    Key_Prolonged_Sound      => 16#4_B0#,
    Key_Kana_A               => 16#4_B1#,
    Key_Kana_I               => 16#4_B2#,
    Key_Kana_U               => 16#4_B3#,
    Key_Kana_E               => 16#4_B4#,
    Key_Kana_O               => 16#4_B5#,
    Key_Kana_Ka              => 16#4_B6#,
    Key_Kana_Ki              => 16#4_B7#,
    Key_Kana_Ku              => 16#4_B8#,
    Key_Kana_Ke              => 16#4_B9#,
    Key_Kana_Ko              => 16#4_BA#,
    Key_Kana_Sa              => 16#4_BB#,
    Key_Kana_Shi             => 16#4_BC#,
    Key_Kana_Su              => 16#4_BD#,
    Key_Kana_Se              => 16#4_BE#,
    Key_Kana_So              => 16#4_BF#,
    Key_Kana_Ta              => 16#4_C0#,
    Key_Kana_Chi             => 16#4_C1#,
    Key_Kana_Tsu             => 16#4_C2#,
    Key_Kana_Te              => 16#4_C3#,
    Key_Kana_To              => 16#4_C4#,
    Key_Kana_Na              => 16#4_C5#,
    Key_Kana_Ni              => 16#4_C6#,
    Key_Kana_Nu              => 16#4_C7#,
    Key_Kana_Ne              => 16#4_C8#,
    Key_Kana_No              => 16#4_C9#,
    Key_Kana_Ha              => 16#4_CA#,
    Key_Kana_Hi              => 16#4_CB#,
    Key_Kana_Fu              => 16#4_CC#,
    Key_Kana_He              => 16#4_CD#,
    Key_Kana_Ho              => 16#4_CE#,
    Key_Kana_Ma              => 16#4_CF#,
    Key_Kana_Mi              => 16#4_D0#,
    Key_Kana_Mu              => 16#4_D1#,
    Key_Kana_Me              => 16#4_D2#,
    Key_Kana_Mo              => 16#4_D3#,
    Key_Kana_Ya              => 16#4_D4#,
    Key_Kana_Yu              => 16#4_D5#,
    Key_Kana_Yo              => 16#4_D6#,
    Key_Kana_Ra              => 16#4_D7#,
    Key_Kana_Ri              => 16#4_D8#,
    Key_Kana_Ru              => 16#4_D9#,
    Key_Kana_Re              => 16#4_DA#,
    Key_Kana_Ro              => 16#4_DB#,
    Key_Kana_Wa              => 16#4_DC#,
    Key_Kana_N               => 16#4_DD#,
    Key_Voiced_Sound         => 16#4_DE#,
    Key_Semi_Voiced_Sound    => 16#4_DF#,


--  Arabic
--  Byte 3 = 5


    Key_Arabic_Comma             => 16#5_AC#,
    Key_Arabic_Semicolon         => 16#5_BB#,
    Key_Arabic_Question_Mark     => 16#5_BF#,
    Key_Arabic_Hamza             => 16#5_C1#,
    Key_Arabic_Madda_On_Alef     => 16#5_C2#,
    Key_Arabic_Hamza_On_Alef     => 16#5_C3#,
    Key_Arabic_Hamza_On_Waw      => 16#5_C4#,
    Key_Arabic_Hamza_Under_Alef  => 16#5_C5#,
    Key_Arabic_Hamza_On_Yeh      => 16#5_C6#,
    Key_Arabic_Alef              => 16#5_C7#,
    Key_Arabic_Beh               => 16#5_C8#,
    Key_Arabic_Teh_Marbuta       => 16#5_C9#,
    Key_Arabic_Teh               => 16#5_CA#,
    Key_Arabic_Theh              => 16#5_CB#,
    Key_Arabic_Jeem              => 16#5_CC#,
    Key_Arabic_Hah               => 16#5_CD#,
    Key_Arabic_Khah              => 16#5_CE#,
    Key_Arabic_Dal               => 16#5_CF#,
    Key_Arabic_Thal              => 16#5_D0#,
    Key_Arabic_Ra                => 16#5_D1#,
    Key_Arabic_Zain              => 16#5_D2#,
    Key_Arabic_Seen              => 16#5_D3#,
    Key_Arabic_Sheen             => 16#5_D4#,
    Key_Arabic_Sad               => 16#5_D5#,
    Key_Arabic_Dad               => 16#5_D6#,
    Key_Arabic_Tah               => 16#5_D7#,
    Key_Arabic_Zah               => 16#5_D8#,
    Key_Arabic_Ain               => 16#5_D9#,
    Key_Arabic_Ghain             => 16#5_DA#,
    Key_Arabic_Tatweel           => 16#5_E0#,
    Key_Arabic_Feh               => 16#5_E1#,
    Key_Arabic_Qaf               => 16#5_E2#,
    Key_Arabic_Kaf               => 16#5_E3#,
    Key_Arabic_Lam               => 16#5_E4#,
    Key_Arabic_Meem              => 16#5_E5#,
    Key_Arabic_Noon              => 16#5_E6#,
    Key_Arabic_Ha                => 16#5_E7#,
    Key_Arabic_Waw               => 16#5_E8#,
    Key_Arabic_Alef_Maksura      => 16#5_E9#,
    Key_Arabic_Yeh               => 16#5_EA#,
    Key_Arabic_Fatha_Tan         => 16#5_EB#,
    Key_Arabic_Damma_Tan         => 16#5_EC#,
    Key_Arabic_Kasra_Tan         => 16#5_ED#,
    Key_Arabic_Fatha             => 16#5_EE#,
    Key_Arabic_Damma             => 16#5_EF#,
    Key_Arabic_Kasra             => 16#5_F0#,
    Key_Arabic_Shadda            => 16#5_F1#,
    Key_Arabic_Sukun             => 16#5_F2#,


-- Cyrillic
-- Byte 3 = 6


    Key_Serbian_Lc_Dje         => 16#6_A1#,
    Key_Macedonia_Lc_Gje       => 16#6_A2#,
    Key_Cyrillic_Lc_Io         => 16#6_A3#,
    Key_Ukrainian_Lc_Ie        => 16#6_A4#,
    Key_Macedonia_Lc_Dse       => 16#6_A5#,
    Key_Ukrainian_Lc_I         => 16#6_A6#,
    Key_Ukrainian_Lc_Yi        => 16#6_A7#,
    Key_Cyrillic_Lc_Je         => 16#6_A8#,
    Key_Cyrillic_Lc_Lje        => 16#6_A9#,
    Key_Cyrillic_Lc_Nje        => 16#6_AA#,
    Key_Serbian_Lc_Tshe        => 16#6_AB#,
    Key_Macedonia_Lc_Kje       => 16#6_AC#,
    Key_Byelorussian_Lc_Shortu => 16#6_AE#,
    Key_Cyrillic_Lc_Dzhe       => 16#6_AF#,
    Key_Numero_Sign            => 16#6_B0#,
    Key_Serbian_Dje            => 16#6_B1#,
    Key_Macedonia_Gje          => 16#6_B2#,
    Key_Cyrillic_Io            => 16#6_B3#,
    Key_Ukrainian_Ie           => 16#6_B4#,
    Key_Macedonia_Dse          => 16#6_B5#,
    Key_Ukrainian_I            => 16#6_B6#,
    Key_Ukrainian_Yi           => 16#6_B7#,
    Key_Cyrillic_Je            => 16#6_B8#,
    Key_Cyrillic_Lje           => 16#6_B9#,
    Key_Cyrillic_Nje           => 16#6_BA#,
    Key_Serbian_Tshe           => 16#6_BB#,
    Key_Macedonia_Kje          => 16#6_BC#,
    Key_Byelorussian_Shortu    => 16#6_BE#,
    Key_Cyrillic_Dzhe          => 16#6_BF#,
    Key_Cyrillic_Lc_Yu         => 16#6_C0#,
    Key_Cyrillic_Lc_A          => 16#6_C1#,
    Key_Cyrillic_Lc_Be         => 16#6_C2#,
    Key_Cyrillic_Lc_Tse        => 16#6_C3#,
    Key_Cyrillic_Lc_De         => 16#6_C4#,
    Key_Cyrillic_Lc_Ie         => 16#6_C5#,
    Key_Cyrillic_Lc_Ef         => 16#6_C6#,
    Key_Cyrillic_Lc_Ghe        => 16#6_C7#,
    Key_Cyrillic_Lc_Ha         => 16#6_C8#,
    Key_Cyrillic_Lc_I          => 16#6_C9#,
    Key_Cyrillic_Lc_Shorti     => 16#6_CA#,
    Key_Cyrillic_Lc_Ka         => 16#6_CB#,
    Key_Cyrillic_Lc_El         => 16#6_CC#,
    Key_Cyrillic_Lc_Em         => 16#6_CD#,
    Key_Cyrillic_Lc_En         => 16#6_CE#,
    Key_Cyrillic_Lc_O          => 16#6_CF#,
    Key_Cyrillic_Lc_Pe         => 16#6_D0#,
    Key_Cyrillic_Lc_Ya         => 16#6_D1#,
    Key_Cyrillic_Lc_Er         => 16#6_D2#,
    Key_Cyrillic_Lc_Es         => 16#6_D3#,
    Key_Cyrillic_Lc_Te         => 16#6_D4#,
    Key_Cyrillic_Lc_U          => 16#6_D5#,
    Key_Cyrillic_Lc_Zhe        => 16#6_D6#,
    Key_Cyrillic_Lc_Ve         => 16#6_D7#,
    Key_Cyrillic_Lc_Softsign   => 16#6_D8#,
    Key_Cyrillic_Lc_Yeru       => 16#6_D9#,
    Key_Cyrillic_Lc_Ze         => 16#6_DA#,
    Key_Cyrillic_Lc_Sha        => 16#6_DB#,
    Key_Cyrillic_Lc_E          => 16#6_DC#,
    Key_Cyrillic_Lc_Shcha      => 16#6_DD#,
    Key_Cyrillic_Lc_Che        => 16#6_DE#,
    Key_Cyrillic_Lc_Hardsign   => 16#6_DF#,
    Key_Cyrillic_Yu            => 16#6_E0#,
    Key_Cyrillic_A             => 16#6_E1#,
    Key_Cyrillic_Be            => 16#6_E2#,
    Key_Cyrillic_Tse           => 16#6_E3#,
    Key_Cyrillic_De            => 16#6_E4#,
    Key_Cyrillic_Ie            => 16#6_E5#,
    Key_Cyrillic_Ef            => 16#6_E6#,
    Key_Cyrillic_Ghe           => 16#6_E7#,
    Key_Cyrillic_Ha            => 16#6_E8#,
    Key_Cyrillic_I             => 16#6_E9#,
    Key_Cyrillic_Shorti        => 16#6_EA#,
    Key_Cyrillic_Ka            => 16#6_EB#,
    Key_Cyrillic_El            => 16#6_EC#,
    Key_Cyrillic_Em            => 16#6_ED#,
    Key_Cyrillic_En            => 16#6_EE#,
    Key_Cyrillic_O             => 16#6_EF#,
    Key_Cyrillic_Pe            => 16#6_F0#,
    Key_Cyrillic_Ya            => 16#6_F1#,
    Key_Cyrillic_Er            => 16#6_F2#,
    Key_Cyrillic_Es            => 16#6_F3#,
    Key_Cyrillic_Te            => 16#6_F4#,
    Key_Cyrillic_U             => 16#6_F5#,
    Key_Cyrillic_Zhe           => 16#6_F6#,
    Key_Cyrillic_Ve            => 16#6_F7#,
    Key_Cyrillic_Softsign      => 16#6_F8#,
    Key_Cyrillic_Yeru          => 16#6_F9#,
    Key_Cyrillic_Ze            => 16#6_FA#,
    Key_Cyrillic_Sha           => 16#6_FB#,
    Key_Cyrillic_E             => 16#6_FC#,
    Key_Cyrillic_Shcha         => 16#6_FD#,
    Key_Cyrillic_Che           => 16#6_FE#,
    Key_Cyrillic_Hardsign      => 16#6_FF#,



-- Greek
-- Byte 3 = 7



    Key_Greek_Alpha_Accent               => 16#7_A1#,
    Key_Greek_Epsilon_Accent             => 16#7_A2#,
    Key_Greek_Eta_Accent                 => 16#7_A3#,
    Key_Greek_Iota_Accent                => 16#7_A4#,
    Key_Greek_Iota_Diaeresis             => 16#7_A5#,
    Key_Greek_Omicron_Accent             => 16#7_A7#,
    Key_Greek_Upsilon_Accent             => 16#7_A8#,
    Key_Greek_Upsilon_Dieresis           => 16#7_A9#,
    Key_Greek_Omega_Accent               => 16#7_AB#,
    Key_Greek_Accent_Dieresis            => 16#7_AE#,
    Key_Greek_Horiz_Bar                  => 16#7_AF#,
    Key_Greek_Lc_Alpha_Accent            => 16#7_B1#,
    Key_Greek_Lc_Epsilon_Accent          => 16#7_B2#,
    Key_Greek_Lc_Eta_Accent              => 16#7_B3#,
    Key_Greek_Lc_Iota_Accent             => 16#7_B4#,
    Key_Greek_Lc_Iota_Dieresis           => 16#7_B5#,
    Key_Greek_Lc_Iota_Accent_Dieresis    => 16#7_B6#,
    Key_Greek_Lc_Omicron_Accent          => 16#7_B7#,
    Key_Greek_Lc_Upsilon_Accent          => 16#7_B8#,
    Key_Greek_Lc_Upsilon_Dieresis        => 16#7_B9#,
    Key_Greek_Lc_Upsilon_Accent_Dieresis => 16#7_BA#,
    Key_Greek_Lc_Omega_Accent            => 16#7_BB#,
    Key_Greek_Alpha                      => 16#7_C1#,
    Key_Greek_Beta                       => 16#7_C2#,
    Key_Greek_Gamma                      => 16#7_C3#,
    Key_Greek_Delta                      => 16#7_C4#,
    Key_Greek_Epsilon                    => 16#7_C5#,
    Key_Greek_Zeta                       => 16#7_C6#,
    Key_Greek_Eta                        => 16#7_C7#,
    Key_Greek_Theta                      => 16#7_C8#,
    Key_Greek_Iota                       => 16#7_C9#,
    Key_Greek_Kappa                      => 16#7_CA#,
    Key_Greek_Lambda                     => 16#7_CB#,
    Key_Greek_Mu                         => 16#7_CC#,
    Key_Greek_Nu                         => 16#7_CD#,
    Key_Greek_Xi                         => 16#7_CE#,
    Key_Greek_Omicron                    => 16#7_CF#,
    Key_Greek_Pi                         => 16#7_D0#,
    Key_Greek_Rho                        => 16#7_D1#,
    Key_Greek_Sigma                      => 16#7_D2#,
    Key_Greek_Tau                        => 16#7_D4#,
    Key_Greek_Upsilon                    => 16#7_D5#,
    Key_Greek_Phi                        => 16#7_D6#,
    Key_Greek_Chi                        => 16#7_D7#,
    Key_Greek_Psi                        => 16#7_D8#,
    Key_Greek_Omega                      => 16#7_D9#,
    Key_Greek_Lc_Alpha                   => 16#7_E1#,
    Key_Greek_Lc_Beta                    => 16#7_E2#,
    Key_Greek_Lc_Gamma                   => 16#7_E3#,
    Key_Greek_Lc_Delta                   => 16#7_E4#,
    Key_Greek_Lc_Epsilon                 => 16#7_E5#,
    Key_Greek_Lc_Zeta                    => 16#7_E6#,
    Key_Greek_Lc_Eta                     => 16#7_E7#,
    Key_Greek_Lc_Theta                   => 16#7_E8#,
    Key_Greek_Lc_Iota                    => 16#7_E9#,
    Key_Greek_Lc_Kappa                   => 16#7_EA#,
    Key_Greek_Lc_Lambda                  => 16#7_EB#,
    Key_Greek_Lc_Mu                      => 16#7_EC#,
    Key_Greek_Lc_Nu                      => 16#7_ED#,
    Key_Greek_Lc_Xi                      => 16#7_EE#,
    Key_Greek_Lc_Omicron                 => 16#7_EF#,
    Key_Greek_Lc_Pi                      => 16#7_F0#,
    Key_Greek_Lc_Rho                     => 16#7_F1#,
    Key_Greek_Lc_Sigma                   => 16#7_F2#,
    Key_Greek_Final_Small_Sigma          => 16#7_F3#,
    Key_Greek_Lc_Tau                     => 16#7_F4#,
    Key_Greek_Lc_Upsilon                 => 16#7_F5#,
    Key_Greek_Lc_Phi                     => 16#7_F6#,
    Key_Greek_Lc_Chi                     => 16#7_F7#,
    Key_Greek_Lc_Psi                     => 16#7_F8#,
    Key_Greek_Lc_Omega                   => 16#7_F9#,



-- Technical
-- Byte 3 = 8



    Key_Left_Radical                   => 16#8_A1#,
    Key_Top_Left_Radical               => 16#8_A2#,
    Key_Horiz_Connector                => 16#8_A3#,
    Key_Top_Integral                   => 16#8_A4#,
    Key_Bot_Integral                   => 16#8_A5#,
    Key_Vert_Connector                 => 16#8_A6#,
    Key_Top_Left_Sq_Bracket            => 16#8_A7#,
    Key_Bot_Left_Sq_Bracket            => 16#8_A8#,
    Key_Top_Right_Sq_Bracket           => 16#8_A9#,
    Key_Bot_Right_Sq_Bracket           => 16#8_AA#,
    Key_Top_Left_Parens                => 16#8_AB#,
    Key_Bot_Left_Parens                => 16#8_AC#,
    Key_Top_Right_Parens               => 16#8_AD#,
    Key_Bot_Right_Parens               => 16#8_AE#,
    Key_Left_Middle_Curly_Brace        => 16#8_AF#,
    Key_Right_Middle_Curly_Brace       => 16#8_B0#,
    Key_Top_Left_Summation             => 16#8_B1#,
    Key_Bot_Left_Summation             => 16#8_B2#,
    Key_Top_Vert_Summation_Connector   => 16#8_B3#,
    Key_Bot_Vert_Summation_Connector   => 16#8_B4#,
    Key_Top_Right_Summation            => 16#8_B5#,
    Key_Bot_Right_Summation            => 16#8_B6#,
    Key_Right_Middle_Summation         => 16#8_B7#,
    Key_Less_Than_Equal                => 16#8_BC#,
    Key_Not_Equal                      => 16#8_BD#,
    Key_Greater_Than_Equal             => 16#8_BE#,
    Key_Integral                       => 16#8_BF#,
    Key_Therefore                      => 16#8_C0#,
    Key_Variation                      => 16#8_C1#,
    Key_Infinity                       => 16#8_C2#,
    Key_Nabla                          => 16#8_C5#,
    Key_Approximate                    => 16#8_C8#,
    Key_Similar_Equal                  => 16#8_C9#,
    Key_If_Only_If                     => 16#8_CD#,
    Key_Implies                        => 16#8_CE#,
    Key_Identical                      => 16#8_CF#,
    Key_Radical                        => 16#8_D6#,
    Key_Included_In                    => 16#8_DA#,
    Key_Includes                       => 16#8_DB#,
    Key_Intersection                   => 16#8_DC#,
    Key_Union                          => 16#8_DD#,
    Key_Logical_And                    => 16#8_DE#,
    Key_Logical_Or                     => 16#8_DF#,
    Key_Partial_Derivative             => 16#8_EF#,
    Key_Function                       => 16#8_F6#,
    Key_Left_Arrow                     => 16#8_FB#,
    Key_Up_Arrow                       => 16#8_FC#,
    Key_Right_Arrow                    => 16#8_FD#,
    Key_Down_Arrow                     => 16#8_FE#,



--  Special
--  Byte 3 = 9



    Key_Blank                => 16#9_DF#,
    Key_Solid_Diamond        => 16#9_E0#,
    Key_Checker_Board        => 16#9_E1#,
    Key_Ht                   => 16#9_E2#,
    Key_Ff                   => 16#9_E3#,
    Key_Cr                   => 16#9_E4#,
    Key_Lf                   => 16#9_E5#,
    Key_Nl                   => 16#9_E8#,
    Key_Vt                   => 16#9_E9#,
    Key_Low_Right_Corner     => 16#9_EA#,
    Key_Up_Right_Corner      => 16#9_EB#,
    Key_Up_Left_Corner       => 16#9_EC#,
    Key_Low_Left_Corner      => 16#9_ED#,
    Key_Crossing_Lines       => 16#9_EE#,
    Key_Horiz_Line_Scan1     => 16#9_EF#,
    Key_Horiz_Line_Scan3     => 16#9_F0#,
    Key_Horiz_Line_Scan5     => 16#9_F1#,
    Key_Horiz_Line_Scan7     => 16#9_F2#,
    Key_Horiz_Line_Scan9     => 16#9_F3#,
    Key_Left_T               => 16#9_F4#,
    Key_Right_T              => 16#9_F5#,
    Key_Bot_T                => 16#9_F6#,
    Key_Top_T                => 16#9_F7#,
    Key_Vert_Bar             => 16#9_F8#,



--  Publishing
--  Byte 3 = a



    Key_Em_Space                    => 16#A_A1#,
    Key_En_Space                    => 16#A_A2#,
    Key_Em3_Space                   => 16#A_A3#,
    Key_Em4_Space                   => 16#A_A4#,
    Key_Digit_Space                 => 16#A_A5#,
    Key_Punct_Space                 => 16#A_A6#,
    Key_Thin_Space                  => 16#A_A7#,
    Key_Hair_Space                  => 16#A_A8#,
    Key_Em_Dash                     => 16#A_A9#,
    Key_En_Dash                     => 16#A_AA#,
    Key_Signif_Blank                => 16#A_AC#,
    Key_Ellipsis                    => 16#A_AE#,
    Key_Doub_Baseline_Dot           => 16#A_AF#,
    Key_One_Third                   => 16#A_B0#,
    Key_Two_Thirds                  => 16#A_B1#,
    Key_One_Fifth                   => 16#A_B2#,
    Key_Two_Fifths                  => 16#A_B3#,
    Key_Three_Fifths                => 16#A_B4#,
    Key_Four_Fifths                 => 16#A_B5#,
    Key_One_Sixth                   => 16#A_B6#,
    Key_Five_Sixths                 => 16#A_B7#,
    Key_Care_Of                     => 16#A_B8#,
    Key_Fig_Dash                    => 16#A_BB#,
    Key_Left_Angle_Bracket          => 16#A_BC#,
    Key_Decimal_Point               => 16#A_BD#,
    Key_Right_Angle_Bracket         => 16#A_BE#,
    Key_Marker                      => 16#A_BF#,
    Key_One_Eighth                  => 16#A_C3#,
    Key_Three_Eighths               => 16#A_C4#,
    Key_Five_Eighths                => 16#A_C5#,
    Key_Seven_Eighths               => 16#A_C6#,
    Key_Trade_Mark                  => 16#A_C9#,
    Key_Signature_Mark              => 16#A_CA#,
    Key_Trade_Mark_In_Circle        => 16#A_CB#,
    Key_Left_Open_Triangle          => 16#A_CC#,
    Key_Right_Open_Triangle         => 16#A_CD#,
    Key_Em_Open_Circle              => 16#A_CE#,
    Key_Em_Open_Rectangle           => 16#A_CF#,
    Key_Left_Single_Quote_Mark      => 16#A_D0#,
    Key_Right_Single_Quote_Mark     => 16#A_D1#,
    Key_Left_Double_Quote_Mark      => 16#A_D2#,
    Key_Right_Double_Quote_Mark     => 16#A_D3#,
    Key_Prescription                => 16#A_D4#,
    Key_Minutes                     => 16#A_D6#,
    Key_Seconds                     => 16#A_D7#,
    Key_Latin_Cross                 => 16#A_D9#,
    Key_Hexagram                    => 16#A_DA#,
    Key_Filled_Rect_Bullet          => 16#A_DB#,
    Key_Filled_Left_Tri_Bullet      => 16#A_DC#,
    Key_Filled_Right_Tri_Bullet     => 16#A_DD#,
    Key_Em_Filled_Circle            => 16#A_DE#,
    Key_Em_Filled_Rect              => 16#A_DF#,
    Key_En_Open_Circ_Bullet         => 16#A_E0#,
    Key_En_Open_Square_Bullet       => 16#A_E1#,
    Key_Open_Rect_Bullet            => 16#A_E2#,
    Key_Open_Tri_Bullet_Up          => 16#A_E3#,
    Key_Open_Tri_Bullet_Down        => 16#A_E4#,
    Key_Open_Star                   => 16#A_E5#,
    Key_En_Filled_Circ_Bullet       => 16#A_E6#,
    Key_En_Filled_Sqare_Bullet      => 16#A_E7#,
    Key_Filled_Tri_Bullet_Up        => 16#A_E8#,
    Key_Filled_Tri_Bullet_Down      => 16#A_E9#,
    Key_Left_Pointer                => 16#A_EA#,
    Key_Right_Pointer               => 16#A_EB#,
    Key_Club                        => 16#A_EC#,
    Key_Diamond                     => 16#A_ED#,
    Key_Heart                       => 16#A_EE#,
    Key_Maltese_Cross               => 16#A_F0#,
    Key_Dagger                      => 16#A_F1#,
    Key_Double_Dagger               => 16#A_F2#,
    Key_Check_Mark                  => 16#A_F3#,
    Key_Ballot_Cross                => 16#A_F4#,
    Key_Musical_Sharp               => 16#A_F5#,
    Key_Musical_Flat                => 16#A_F6#,
    Key_Male_Symbol                 => 16#A_F7#,
    Key_Female_Symbol               => 16#A_F8#,
    Key_Telephone                   => 16#A_F9#,
    Key_Telephone_Recorder          => 16#A_FA#,
    Key_Phonograph_Copyright        => 16#A_FB#,
    Key_Caret                       => 16#A_FC#,
    Key_Single_Low_Quote_Mark       => 16#A_FD#,
    Key_Double_Low_Quote_Mark       => 16#A_FE#,
    Key_Cursor                      => 16#A_FF#,


--  APL
--  Byte 3 = b

    Key_Left_Caret         => 16#B_A3#,
    Key_Right_Caret        => 16#B_A6#,
    Key_Down_Caret         => 16#B_A8#,
    Key_Up_Caret           => 16#B_A9#,
    Key_Over_Bar           => 16#B_C0#,
    Key_Down_Tack          => 16#B_C2#,
    Key_Up_Shoe            => 16#B_C3#,
    Key_Down_Stile         => 16#B_C4#,
    Key_Under_Bar          => 16#B_C6#,
    Key_Jot                => 16#B_CA#,
    Key_Quad               => 16#B_CC#,
    Key_Up_Tack            => 16#B_CE#,
    Key_Circle             => 16#B_CF#,
    Key_Up_Stile           => 16#B_D3#,
    Key_Down_Shoe          => 16#B_D6#,
    Key_Right_Shoe         => 16#B_D8#,
    Key_Left_Shoe          => 16#B_DA#,
    Key_Left_Tack          => 16#B_DC#,
    Key_Right_Tack         => 16#B_FC#,



-- Hebrew
-- Byte 3 = c

    Key_Hebrew_Double_Low_Line     => 16#C_DF#,
    Key_Hebrew_Aleph               => 16#C_E0#,
    Key_Hebrew_Bet                 => 16#C_E1#,
    Key_Hebrew_Gimel               => 16#C_E2#,
    Key_Hebrew_Dalet               => 16#C_E3#,
    Key_Hebrew_He                  => 16#C_E4#,
    Key_Hebrew_Waw                 => 16#C_E5#,
    Key_Hebrew_Zain                => 16#C_E6#,
    Key_Hebrew_Chet                => 16#C_E7#,
    Key_Hebrew_Tet                 => 16#C_E8#,
    Key_Hebrew_Yod                 => 16#C_E9#,
    Key_Hebrew_Final_Kaph          => 16#C_EA#,
    Key_Hebrew_Kaph                => 16#C_EB#,
    Key_Hebrew_Lamed               => 16#C_EC#,
    Key_Hebrew_Final_Mem           => 16#C_ED#,
    Key_Hebrew_Mem                 => 16#C_EE#,
    Key_Hebrew_Final_Nun           => 16#C_EF#,
    Key_Hebrew_Nun                 => 16#C_F0#,
    Key_Hebrew_Samech              => 16#C_F1#,
    Key_Hebrew_Ayin                => 16#C_F2#,
    Key_Hebrew_Final_Pe            => 16#C_F3#,
    Key_Hebrew_Pe                  => 16#C_F4#,
    Key_Hebrew_Final_Zade          => 16#C_F5#,
    Key_Hebrew_Zade                => 16#C_F6#,
    Key_Hebrew_Qoph                => 16#C_F7#,
    Key_Hebrew_Resh                => 16#C_F8#,
    Key_Hebrew_Shin                => 16#C_F9#,
    Key_Hebrew_Taw                 => 16#C_FA#,


-- TTY Functions, cleverly chosen to map to ascii, for convenience of
-- programming, but could have been arbitrary (at the cost of lookup
-- tables in client code.

    Key_Backspace    => 16#FF_08#, -- back space, back char
    Key_Tab          => 16#FF_09#,
    Key_Line_Feed    => 16#FF_0A#, -- Linefeed, LF
    Key_Clear        => 16#FF_0B#,
    Key_Return       => 16#FF_0D#, -- Return, enter
    Key_Pause        => 16#FF_13#, -- Pause, hold
    Key_Scroll_Lock  => 16#FF_14#,
    Key_Escape       => 16#FF_1B#,



-- International & multi-key character composition

    Key_Multi_Key          => 16#FF_20#,

-- Japanese keyboard support

    Key_Kanji              => 16#FF_21#,  -- Kanji, Kanji convert
    Key_Muhenkan           => 16#FF_22#,  -- Cancel Conversion
    Key_Henkan_Mode        => 16#FF_23#,  -- Start/Stop Conversion
    Key_Romaji             => 16#FF_24#,  -- to Romaji
    Key_Hiragana           => 16#FF_25#,  -- to Hiragana
    Key_Katakana           => 16#FF_26#,  -- to Katakana
    Key_Hiragana_Katakana  => 16#FF_27#,  -- Hiragana/Katakana toggle
    Key_Zenkaku            => 16#FF_28#,  -- to Zenkaku
    Key_Hankaku            => 16#FF_29#,  -- to Hankaku
    Key_Zenkaku_Hankaku    => 16#FF_2A#,  -- Zenkaku/Hankaku toggle
    Key_Touroku            => 16#FF_2B#,  -- Add to Dictionary
    Key_Massyo             => 16#FF_2C#,  -- Delete from Dictionary
    Key_Kana_Lock          => 16#FF_2D#,  -- Kana Lock
    Key_Kana_Shift         => 16#FF_2E#,  -- Kana Shift
    Key_Eisu_Shift         => 16#FF_2F#,  -- Alphanumeric Shift
    Key_Eisu_Toggle        => 16#FF_30#,  -- Alphanumeric toggle

-- Cursor control & motion

    Key_Home      => 16#FF_50#,
    Key_Left      => 16#FF_51#,  -- Move left, left arrow
    Key_Up        => 16#FF_52#,  -- Move up, up arrow
    Key_Right     => 16#FF_53#,  -- Move right, right arrow
    Key_Down      => 16#FF_54#,  -- Move down, down arrow
    Key_Prior     => 16#FF_55#,  -- Prior, previous
    Key_Next      => 16#FF_56#,  -- Next
    Key_End       => 16#FF_57#,  -- EOL
    Key_Begin     => 16#FF_58#,  -- BOL


-- Misc Functions

    Key_Select        => 16#FF_60#,  -- Select, mark
    Key_Print         => 16#FF_61#,
    Key_Execute       => 16#FF_62#,  -- Execute, run, do
    Key_Insert        => 16#FF_63#,  -- Insert, insert here
    Key_Undo          => 16#FF_65#,  -- Undo, oops
    Key_Redo          => 16#FF_66#,  -- redo, again
    Key_Menu          => 16#FF_67#,
    Key_Find          => 16#FF_68#,  -- Find, search
    Key_Cancel        => 16#FF_69#,  -- Cancel, stop, abort, exit
    Key_Help          => 16#FF_6A#,  -- Help, ?
    Key_Break         => 16#FF_6B#,
    Key_Mode_Switch   => 16#FF_7E#,  -- Character set switch
    Key_Num_Lock      => 16#FF_7F#,

-- Keypad Functions, keypad numbers cleverly chosen to map to ascii

    Keypad_Space       => 16#FF_80#, -- space
    Keypad_Tab         => 16#FF_89#,
    Keypad_Enter       => 16#FF_8D#, -- enter
    Keypad_F1          => 16#FF_91#, -- PF1, Keypad_A, ...
    Keypad_F2          => 16#FF_92#,
    Keypad_F3          => 16#FF_93#,
    Keypad_F4          => 16#FF_94#,
    Keypad_Multiply    => 16#FF_AA#,
    Keypad_Add         => 16#FF_AB#,
    Keypad_Separator   => 16#FF_AC#, -- separator, often comma
    Keypad_Subtract    => 16#FF_AD#,
    Keypad_Decimal     => 16#FF_AE#,
    Keypad_Divide      => 16#FF_AF#,

    Keypad_0           => 16#FF_B0#,
    Keypad_1           => 16#FF_B1#,
    Keypad_2           => 16#FF_B2#,
    Keypad_3           => 16#FF_B3#,
    Keypad_4           => 16#FF_B4#,
    Keypad_5           => 16#FF_B5#,
    Keypad_6           => 16#FF_B6#,
    Keypad_7           => 16#FF_B7#,
    Keypad_8           => 16#FF_B8#,
    Keypad_9           => 16#FF_B9#,
    Keypad_Equal       => 16#FF_BD#, -- equals


-- Auxilliary Functions; note the duplicate definitions for left and right
-- function keys;  Sun keyboards and a few other manufactures have such
-- function key groups on the left and/or right sides of the keyboard.
-- We've not found a keyboard with more than 35 function keys total.


    Key_F1                 => 16#FF_BE#,
    Key_F2                 => 16#FF_BF#,
    Key_F3                 => 16#FF_C0#,
    Key_F4                 => 16#FF_C1#,
    Key_F5                 => 16#FF_C2#,
    Key_F6                 => 16#FF_C3#,
    Key_F7                 => 16#FF_C4#,
    Key_F8                 => 16#FF_C5#,
    Key_F9                 => 16#FF_C6#,
    Key_F10                => 16#FF_C7#,
    Key_F11                => 16#FF_C8#,
    Key_F12                => 16#FF_C9#,
    Key_F13                => 16#FF_CA#,
    Key_F14                => 16#FF_CB#,
    Key_F15                => 16#FF_CC#,
    Key_F16                => 16#FF_CD#,
    Key_F17                => 16#FF_CE#,
    Key_F18                => 16#FF_CF#,
    Key_F19                => 16#FF_D0#,
    Key_F20                => 16#FF_D1#,
    Key_F21                => 16#FF_D2#,
    Key_F22                => 16#FF_D3#,
    Key_F23                => 16#FF_D4#,
    Key_F24                => 16#FF_D5#,
    Key_F25                => 16#FF_D6#,
    Key_F26                => 16#FF_D7#,
    Key_F27                => 16#FF_D8#,
    Key_F28                => 16#FF_D9#,
    Key_F29                => 16#FF_DA#,
    Key_F30                => 16#FF_DB#,
    Key_F31                => 16#FF_DC#,
    Key_F32                => 16#FF_DD#,
    Key_F33                => 16#FF_DE#,
    Key_F34                => 16#FF_DF#,
    Key_F35                => 16#FF_E0#,

-- Modifiers

    Key_Shift_L            => 16#FF_E1#,  -- Left shift
    Key_Shift_R            => 16#FF_E2#,  -- Right shift
    Key_Control_L          => 16#FF_E3#,  -- Left control
    Key_Control_R          => 16#FF_E4#,  -- Right control
    Key_Caps_Lock          => 16#FF_E5#,  -- Caps lock
    Key_Shift_Lock         => 16#FF_E6#,  -- Shift lock

    Key_Meta_L             => 16#FF_E7#,  -- Left meta
    Key_Meta_R             => 16#FF_E8#,  -- Right meta
    Key_Alt_L              => 16#FF_E9#,  -- Left alt
    Key_Alt_R              => 16#FF_EA#,  -- Right alt
    Key_Super_L            => 16#FF_EB#,  -- Left super
    Key_Super_R            => 16#FF_EC#,  -- Right super
    Key_Hyper_L            => 16#FF_ED#,  -- Left hyper
    Key_Hyper_R            => 16#FF_EE#,  -- Right hyper


    Key_Delete             => 16#FF_FF#, -- Delete, rubout
    Key_Void_Symbol        => 16#FFFF_FF# ) ;   -- void symbol

    -- Synonyms

    Key_L1  : constant Symbol := Key_F11 ;
    Key_L2  : constant Symbol := Key_F12 ;
    Key_L3  : constant Symbol := Key_F13 ;
    Key_L4  : constant Symbol := Key_F14 ;
    Key_L5  : constant Symbol := Key_F15 ;
    Key_L6  : constant Symbol := Key_F16 ;
    Key_L7  : constant Symbol := Key_F17 ;
    Key_L8  : constant Symbol := Key_F18 ;
    Key_L9  : constant Symbol := Key_F19 ;
    Key_L10 : constant Symbol := Key_F20 ;
    Key_R1  : constant Symbol := Key_F21 ;
    Key_R2  : constant Symbol := Key_F22 ;
    Key_R3  : constant Symbol := Key_F23 ;
    Key_R4  : constant Symbol := Key_F24 ;
    Key_R5  : constant Symbol := Key_F25 ;
    Key_R6  : constant Symbol := Key_F26 ;
    Key_R7  : constant Symbol := Key_F27 ;
    Key_R8  : constant Symbol := Key_F28 ;
    Key_R9  : constant Symbol := Key_F29 ;
    Key_R10 : constant Symbol := Key_F30 ;
    Key_R11 : constant Symbol := Key_F31 ;
    Key_R12 : constant Symbol := Key_F32 ;
    Key_R13 : constant Symbol := Key_F33 ;
    Key_R14 : constant Symbol := Key_F34 ;
    Key_R15 : constant Symbol := Key_F35 ;

    Key_Greek_Lamda    : constant Symbol := Key_Greek_Lambda ;
    Key_Greek_Lc_Lamda : constant Symbol := Key_Greek_Lc_Lambda ;
        
    Key_Henkan        : constant Symbol := Key_Henkan_Mode ;
        
    Key_Arabic_Switch : constant Symbol := Key_Mode_Switch ;
    Key_Greek_Switch  : constant Symbol := Key_Mode_Switch ;
    Key_Hebrew_Switch : constant Symbol := Key_Mode_Switch ;
    Key_Kana_Switch   : constant Symbol := Key_Mode_Switch ;
    Key_Script_Switch : constant Symbol := Key_Mode_Switch ;

    -- Deprecated Values

    Key_Quote_Right       : constant Symbol := Key_Apostrophe ;
    Key_Kappa             : constant Symbol := Key_Kra ;
    Key_Kana_Middle_Dot   : constant Symbol := Key_Kana_Conjunctive ;
    Key_Kana_Lc_Tu        : constant Symbol := Key_Kana_Lc_Tsu ;
    Key_Kana_Ti           : constant Symbol := Key_Kana_Chi ;
    Key_Kana_Tu           : constant Symbol := Key_Kana_Tsu ;
    Key_Kana_Hu           : constant Symbol := Key_Kana_Fu ;
    Key_Arabic_Heh        : constant Symbol := Key_Arabic_Ha ;
    Key_Ukranian_Lc_Je    : constant Symbol := Key_Ukrainian_Lc_Ie ;
    Key_Ukranian_Lc_I     : constant Symbol := Key_Ukrainian_Lc_I ;
    Key_Ukranian_Lc_Yi    : constant Symbol := Key_Ukrainian_Lc_Yi ;
    Key_Serbian_Lc_Je     : constant Symbol := Key_Cyrillic_Lc_Je ;
    Key_Serbian_Lc_Lje    : constant Symbol := Key_Cyrillic_Lc_Lje ;
    Key_Serbian_Lc_Nje    : constant Symbol := Key_Cyrillic_Lc_Nje ;
    Key_Serbian_Lc_Dze    : constant Symbol := Key_Cyrillic_Lc_Dzhe ;
    Key_Ukranian_Je       : constant Symbol := Key_Ukrainian_Ie ;
    Key_Ukranian_I        : constant Symbol := Key_Ukrainian_I ;
    Key_Ukranian_Yi       : constant Symbol := Key_Ukrainian_Yi ;
    Key_Serbian_Je        : constant Symbol := Key_Cyrillic_Je ;
    Key_Serbian_Lje       : constant Symbol := Key_Cyrillic_Lje ;
    Key_Serbian_Nje       : constant Symbol := Key_Cyrillic_Nje ;
    Key_Serbian_Dze       : constant Symbol := Key_Cyrillic_Dzhe ;
    Key_Hebrew_Beth       : constant Symbol := Key_Hebrew_Bet ;
    Key_Hebrew_Gimmel     : constant Symbol := Key_Hebrew_Gimel ;
    Key_Hebrew_Daleth     : constant Symbol := Key_Hebrew_Dalet ;
    Key_Hebrew_Zayin      : constant Symbol := Key_Hebrew_Zain ;
    Key_Hebrew_Het        : constant Symbol := Key_Hebrew_Chet ;
    Key_Hebrew_Teth       : constant Symbol := Key_Hebrew_Tet ;
    Key_Hebrew_Samekh     : constant Symbol := Key_Hebrew_Samech ;
    Key_Hebrew_Final_Zadi : constant Symbol := Key_Hebrew_Final_Zade ;
    Key_Hebrew_Zadi       : constant Symbol := Key_Hebrew_Zade ;
    Key_Hebrew_Kuf        : constant Symbol := Key_Hebrew_Qoph ;
    Key_Hebrew_Taf        : constant Symbol := Key_Hebrew_Taw ;
end X_Key_Symbols ;
